%{!?__python2: %global __python2 %__python}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

%if 0%{?rhel}
    %if 0%{rhel} > 6
        %define with_core 1
    %else
        %define with_core 0
    %endif
%else
    %define with_core 1
%endif


Name:           basset
Version:        0.9
Release:        1%{?dist}
Summary:        Anti-spam system

License:        GPLv3+
URL:            https://pagure.io/basset/
Source0:        Basset-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  python-requests

%if %{with_core}
BuildRequires:  python-pika
BuildRequires:  python-fedora
BuildRequires:  python-flask
BuildRequires:  python-Levenshtein
BuildRequires:  python-pymongo
BuildRequires:  python-mwclient
BuildRequires:  pysubnettree
BuildRequires:  systemd

Requires:       %{name}-filesystem = %{version}
Requires:       pysubnettree
Requires:       python-requests
Requires:       python-pika
Requires:       python-fedora
Requires:       python-flask
Requires:       python-Levenshtein
Requires:       python-pymongo
Requires:       python-mwclient

Requires(pre):  shadow-utils
%endif

%description
Basset anti-spam service backend


%if %{with_core}
%package        frontend
Summary:        Basset frontend
Requires:       %{name}-filesystem = %{version}
Requires(pre):  shadow-utils

%description frontend
Basset frontend wsgi

%package        filesystem
Summary:        Basset filesystem generics

%description filesystem
Basset filesystem generics

%endif

%package -n     mediawiki119-basset
Summary:        Basset mediawiki submitter
Requires:       mediawiki119

%description -n mediawiki119-basset
Mediawiki 1.19 submission plugin

%package -n    trac-basset-plugin
Summary:       Trac Basset submission plugin
Requires:      trac

%description -n trac-basset-plugin
Trac Basset submission plugin


%prep
%setup -n Basset-%{version}


%build
%if %{with_core}
%{__python2} setup.py build
%endif

(
    cd external/trac/
    %{__python2} setup.py build
)


%install
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/basset/

# trac plugin
(
    cd external/trac/
    %{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
)
install external/trac/trac-basset.default.cfg $RPM_BUILD_ROOT%{_sysconfdir}/basset/

# Mediawiki plugin
mkdir -p $RPM_BUILD_ROOT%{_datadir}/mediawiki119/extensions
install external/mediawiki/BassetSubmitter.php $RPM_BUILD_ROOT%{_datadir}/mediawiki119/extensions

# Core
%if %{with_core}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/basset/
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
%{__python2} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
install $RPM_BUILD_ROOT%{_bindir}/basset-frontend $RPM_BUILD_ROOT%{_datadir}/basset/basset-frontend
rm $RPM_BUILD_ROOT%{_bindir}/basset-frontend
install basset-worker.service $RPM_BUILD_ROOT%{_unitdir}
install worker.default.cfg $RPM_BUILD_ROOT%{_sysconfdir}/basset/
install frontend.default.cfg $RPM_BUILD_ROOT%{_sysconfdir}/basset/
%endif


%if %{with_core}
%check
%{__python2} setup.py test


%pre
getent group basset-worker >/dev/null || groupadd -r basset-worker
getent passwd basset-worker >/dev/null || \
    useradd -r -g basset-worker -s /sbin/nologin \
    -c "Basset worker user" basset-worker
exit 0


%pre frontend
getent group basset-frontend >/dev/null || groupadd -r basset-frontend
getent passwd basset-frontend >/dev/null || \
    useradd -r -g basset-frontend -d /usr/share/basset -s /sbin/nologin \
    -c "Basset frontend user" basset-frontend
exit 0


%files
%doc
%{python2_sitelib}/basset/
%{python2_sitelib}/Basset-%{version}*
%{_unitdir}/basset-worker.service
%{_bindir}/basset-worker
%{_bindir}/basset-injector
%{_sysconfdir}/basset/worker.default.cfg

%files frontend
%{_datadir}/basset/basset-frontend
%{_sysconfdir}/basset/frontend.default.cfg

%files filesystem
%dir %{_sysconfdir}/basset
%endif

%files -n mediawiki119-basset
%{_datadir}/mediawiki119/extensions/BassetSubmitter.php

%files -n trac-basset-plugin
%{python2_sitelib}/trac_basset_plugin*
%{_sysconfdir}/basset/trac-basset.default.cfg


%changelog
* Wed Jun 22 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.9-1
- Added phone prefix scoring
- Add ASN scoring
- Moved all processing into plugins

* Tue Jun 07 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.8-1
- Added Trac comment deletion

* Thu Jun 02 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.7-1
- Trac plugin is now in the core spec

* Thu Jun 02 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.6-1
- Add trac attachment support

* Thu Apr 14 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.4-1
- Add Trac plugin

* Tue Mar 22 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.3-1
- Added mediawiki system

* Fri Mar 18 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.2-1
- Release to bump version

* Wed Mar 16 2016 Patrick Uiterwijk <puiterwijk@redhat.com> - 0.1-1
- Initial packaging
